#include <fstream>
#include <kernel>
#include <stdlib>
#include <threads>

struct First { thread t; simple_lock* lock; };
struct Second { thread t; simple_lock* lock; };

DECL_THREAD(First)
DECL_THREAD(Second)

void ?{}( First * this, simple_lock* lock ) { this->lock = lock; }
void ?{}( Second * this, simple_lock* lock ) { this->lock = lock; }

void main(First* this) {
	for(int i = 0; i < 10; i++) {
		sout | "First : Suspend No." | i + 1 | endl;
		yield();
	}
	unlock(this->lock);
}

void main(Second* this) {
	lock(this->lock);	
	for(int i = 0; i < 10; i++) {
		sout | "Second : Suspend No." | i + 1 | endl;
		yield();
	}
}


int main(int argc, char* argv[]) {
	simple_lock lock;
	sout | "User main begin" | endl;
	{
		// processor p;
		{
			scoped(First)  f = { &lock };
			scoped(Second) s = { &lock };
		}
	}
	sout | "User main end" | endl;
}